#!/bin/sh

UNVS=universal-arm
PID=000C

rm -rf /opt/backup
udhcpc -i eth0 &

for i in 1 2 3 4 5;
do
  if [ $i == 5 ]; then
	mount -t vfat -o,codepage=936,iocharset=utf8 /dev/sda /mnt
	  if [ $? -ne 0 ]; then
			echo "mount /dev/sda to /mnt failed"
			continue
	  else
		ls -1t /mnt/creator3*.zip
		if [ $? -eq 0 ];then
			UPDATEFILE=`ls -1t /mnt/creator3*.zip | head -n 1`
			if [ -f $UPDATEFILE ];then
				echo "find update file: ${UPDATEFILE}"
				rm -rf /data/update
				cp -a ${UPDATEFILE} /data/
				if [ $? -ne 0 ];then
					rm -rf /data/creator3*.zip
					sync
					umount /mnt
					break
				fi
				sync
				mkdir -p /data/update
				sync
				SRCFILE="/data/`basename ${UPDATEFILE}`"
				if [ -f ${SRCFILE} ];then
					unzip -o ${SRCFILE} -d /data/update/
					sync
					rm -rf ${SRCFILE}
					if [ -f /data/update/$PID ] || [ -f /data/update/$UNVS ]; then
						chmod a+x /data/update/flashforge_init.sh
						/data/update/flashforge_init.sh 
						if [ $? -eq 0 ];then
							umount /mnt
							rm -rf /data/update
							sleep 10
						fi
						umount /mnt
						rm -rf /data/update
						break
					fi
				fi
			fi
		fi
		if [ -f /mnt/$PID ] || [ -f /mnt/$UNVS ]; then
			if [ -f /mnt/flashforge_init.sh ]; then
				 echo "found /mnt/flashforge_init.sh"
				 chmod a+x /mnt/flashforge_init.sh
				 /mnt/flashforge_init.sh
				 umount /mnt
				 break
			fi
			umount /mnt
		fi
		umount /mnt
	  fi
  else
	  if [ ! -e /dev/sda$i ]; then
		 echo "sda$i not exist"
		 continue
	  fi
	  mount -t vfat -o,codepage=936,iocharset=utf8 /dev/sda$i /mnt
	  if [ $? -ne 0 ]; then
			echo "mount /dev/sda$i to /mnt failed"
			continue
	  else
	  ls -1t /mnt/creator3*.zip
		if [ $? -eq 0 ];then
			UPDATEFILE=`ls -1t /mnt/creator3*.zip | head -n 1`
			if [ -f $UPDATEFILE ];then
				echo "find update file: ${UPDATEFILE}"
				rm -rf /data/update
				cp -a ${UPDATEFILE} /data/
				if [ $? -ne 0 ];then
					rm -rf /data/creator3*.zip
					sync
					umount /mnt
					break
				fi
				sync
				mkdir -p /data/update
				sync
				SRCFILE="/data/`basename ${UPDATEFILE}`"
				if [ -f ${SRCFILE} ];then
					unzip -o ${SRCFILE} -d /data/update/
					sync
					rm -rf ${SRCFILE}
					if [ -f /data/update/$PID ] || [ -f /data/update/$UNVS ]; then
						echo "found /mnt/flashforge_init.sh"
						chmod a+x /data/update/flashforge_init.sh
						/data/update/flashforge_init.sh 
						if [ $? -eq 0 ];then
							echo "update failed"
							umount /mnt
							rm -rf /data/update
							sleep 10
						fi
						umount /mnt
						rm -rf /data/update
						break
					fi
				fi
			fi
		fi
		if [ -f /mnt/$PID ] || [ -f /mnt/$UNVS ]; then
			if [ -f /mnt/flashforge_init.sh ]; then
				 echo "found /mnt/flashforge_init.sh"
				 chmod a+x /mnt/flashforge_init.sh
				 /mnt/flashforge_init.sh
				 umount /mnt
				 break
			fi
			umount /mnt
		fi
		umount /mnt
	  fi
  fi	  
done

echo "Gpio WiFi Power On"
echo 258 >/sys/class/gpio/export
echo out >/sys/class/gpio/gpio258/direction
echo 1 > /sys/class/gpio/gpio258/value
echo 0 > /sys/class/gpio/gpio258/value

echo 259 >/sys/class/gpio/export
echo out >/sys/class/gpio/gpio259/direction
echo 1 > /sys/class/gpio/gpio259/value

ifconfig wlan0 up
wpa_supplicant -d -Dwext -i wlan0 -c /etc/wpa_supplicant.conf -B
sleep 0.1

ifconfig wlan0 | grep wlan0 | grep HWaddr |tr -s ' '| cut -d ' ' -f5 > /opt/WiFiMAC
sync

killall wpa_supplicant
killall wpa_cli

if [ ! "`mount | grep "mmcblk0p3"`" ]; then
	echo "mmcblk0p3 not mounted and will fsck";
	fsck -y /dev/mmcblk0p3 && mount /dev/mmcblk0p3 /data;
fi

                                                                           
if [ ! -d /data ]; then
  	mkdir /data
fi

if [ ! -d /data/log ]; then
  	mkdir /data/log
fi

if [ ! -d /opt/flashforge ];then
	mkdir /opt/flashforge
fi

cd /opt/library/
dirlib=$(ls -ld [0-9]* |awk '/^d/ {print $NF}')                        
for libDir in $dirlib                                                                      
do
    echo $libDir
done                                                                            
LIBTSDIR="/opt/library/$libDir/tslib-1.4-none"
echo $LIBTSDIR

cp -f $LIBTSDIR/etc/pointercal /etc/
cd /opt/software/
stdir=$(ls -ld [0-9]* |awk '/^d/ {print $NF}')
for startDir in $stdir
do
  echo $startDir
done


if [ ! -f /opt/start.bmp ];then
	cp /opt/software/$startDir/start.bmp  /opt/
	cp /opt/software/$startDir/complete.bmp  /opt/
	cp /opt/software/$startDir/play /opt/
fi
if [ ! -f /opt/rerun.sh ];then
    cp -f /opt/software/$startDir/rerun.sh /opt
    cp -f /opt/software/$startDir/mydaemon.out /opt
fi
sync
if [ ! -f /opt/version.cfg ];then
    cp -f /opt/software/$startDir/version.cfg /opt
fi
sync
chmod a+x /opt/mydaemon.out

/opt/mydaemon.out &
/opt/ffstartup-arm -f /opt/ffstartup.cfg &


if [ -d /opt/tslib-1.4-none ]; then
	rm -rf /opt/tslib-1.4-none
fi

if [ -d /opt/openssl-1.0.2d-none ]; then
	rm -rf /opt/openssl-1.0.2d-none
fi

if [ -d /opt//qt4.8.6-none ]; then
	rm -rf /opt/qt4.8.6-none
fi

if [ -d /opt/curl ]; then
	rm -rf /opt/curl
fi

if [ -d /opt/arm-jsoncpp ]; then
	rm -rf /opt/arm-jsoncpp
fi

if [ -d /opt/mjpg-streamer ]; then
	rm -rf /opt/mjpg-streamer
fi

if [ -d /opt/libiconv-1.14-none ]; then
	rm -rf /opt/libiconv-1.14-none
fi
rm -f /opt/md5ArmJson
rm -f /opt/md5Camera
rm -f /opt/md5HEX
rm -f /opt/md5Openssllib


                                                                              
