#!/bin/sh
EXE=creator3-arm
SOFTWAREPACKET=software*
SOFTWAREVERSION="1.4.5"
KERNEL=uImage-creator3*
KERNELPACKET=kernel*
KERNELVERSION="1.5.5"
M3HEX=Creator3.hex
M3HEXPACKET=control*
M3HEXVERSION="4.2.3"
MYDAEMON=mydaemon.out
LIBPACKET=library*
LIBVERSION="1.0.4"
MACHINE=creator3
LOG=/data/log/creator3-arm.log
MYDAEMON=mydaemon.out
MACHINE_ARCH=armv5tejl

WORKDIR=$(cd `dirname $0`; pwd)
echo "WORKDIR="$WORKDIR >> $LOG

#检测机器的架构,错误马上退出
CHECH_ARCH=`uname -m`
if [ "${MACHINE_ARCH}" != "${CHECH_ARCH}" ];then
    echo "Machine architecture error."
	echo ${CHECH_ARCH}
	exit 1
fi

cp $WORKDIR/complete.bmp /opt/
cp $WORKDIR/start.bmp /opt/
cp $WORKDIR/failed.bmp /opt/
cp $WORKDIR/play /opt/

rm -f /data/log/guiderII-arm*
rm -f /data/log/inventor*
rm -f /data/log/creator3*
rm -rf /data/pics
rm -f  /etc/init.d/S99input-event-daemon
mkdir /data/pics



echo "dispaly start on lcd" >> $LOG
if [ -f $WORKDIR/start.bmp ]
then
    cat $WORKDIR/start.bmp > /dev/fb0
fi

if [ ! -d /data/log ]; then
	mkdir /data/log
fi

if [ ! -d /data/pics ]; then
	mkdir /data/pics
fi

if [ ! -d /data/update ]; then
	mkdir /data/update
fi

if [ ! -d /media ]; then
	mkdir /media
fi

if [ ! -d /opt/kernel ]; then
	mkdir /opt/kernel
fi

if [ ! -d /opt/control ]; then
	mkdir /opt/control
fi

if [ ! -d /opt/library ]; then
	mkdir /opt/library
	if [ ! -d /opt/library/fonts ]; then
		mkdir /opt/library/fonts
	fi
fi

if [ ! -d /opt/software ]; then
	mkdir /opt/software
fi



echo "Ethernet MAC Set"
for i in 1 2;
do
	Ethernet_MAC=`sed -n '/ifconfig eth0 hw ether/p' /etc/init.d/rcS | cut -d ' ' -f5 | grep -E '[0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){5}'`
	echo "Ethernet_MAC="$Ethernet_MAC
	echo "Ethernet_MAC len="${#Ethernet_MAC}
	sync
	if [ ! $Ethernet_MAC ] || [ ${#Ethernet_MAC} != 17 ]; then
		macFile=`ls $WORKDIR/mac/mac-* -1 | head -n 1` 
		echo "macFile="$macFile
		if [ ! $macFile ]; then
			echo "no mac address"
			sync
			if [ -f $WORKDIR/no-mac.bmp ]; then
				cat $WORKDIR/no-mac.bmp > /dev/fb0
			fi
			sync
			sleep 1
			halt -f
		fi
		
		Ethernet_MAC_W=`cat $macFile`
		echo "Ethernet_MAC_W="$Ethernet_MAC_W
		sync
		sed -i '/ifconfig/d' /etc/init.d/rcS
		sed -i '3a ifconfig eth0 hw ether '"$Ethernet_MAC_W" /etc/init.d/rcS
		sync
		
		rm -f $macFile
		sync
	else
		break
	fi
done
sync
	
ls -1t $WORKDIR/$KERNELPACKET
if [ $? -eq 0 ]; then
	UIMAGETXZ=`ls -1t $WORKDIR/$KERNELPACKET | head -n 1`
	xz -d  $UIMAGETXZ 
	UIMAGETAR=`ls -1t $WORKDIR/$KERNELPACKET | head -n 1`
	if [ -f $UIMAGETAR ]; then
	    rm -rf /opt/kernel/*	
		mkdir /opt/kernel/temp	
		tar -xf $UIMAGETAR -C /opt/kernel/temp
		if [ ! -d /tmp/disk1 ]; then
			mkdir /tmp/disk1
		fi
		mount -t vfat -o codepage=936,iocharset=utf8 /dev/mmcblk0p1 /tmp/disk1
		if [ $? -ne 0 ]; then
			echo "mount mmcblk0p1 failed" >> $LOG
			sync
			if [ -f $WORKDIR/failed.bmp ]; then
				cat $WORKDIR/failed.bmp > /dev/fb0
			fi
			sync
			sleep 1
			halt -f
		fi	
		cd /opt/kernel/temp
		md5sum -c md5sum.list
		if [ $? -eq 0 ]; then		
			cp -rf /opt/kernel/temp /opt/kernel/$KERNELVERSION
			rm -rf /opt/kernel/temp
			cd /opt/kernel/
			rm -rf $oldkerVer
			UIMAGE=`ls -1t /opt/kernel/$KERNELVERSION/$KERNEL | head -n 1`
			if [ -f $UIMAGE ]; then
				echo "update uImage" >> $LOG
				rm -f /tmp/disk1/uImage
				cp -vf $UIMAGE /tmp/disk1/uImage
				sync	
				echo "update uImage success" >> $LOG
				umount /tmp/disk1
				rm -r /tmp/disk1
			fi
		else
			echo "md5sum failed" >> $LOG
			if [ -f $WORKDIR/failed.bmp ]; then
				cat $WORKDIR/failed.bmp > /dev/fb0
			fi
			sync
			sleep 1
			halt -f
		fi	
	fi
fi

sync

ls -1t $WORKDIR/$M3HEXPACKET
if [ $? -eq 0 ]; then
	M3HEXXZ=`ls -1t $WORKDIR/$M3HEXPACKET | head -n 1`
	xz -d  $M3HEXXZ
	M3HEXTAR=`ls -1t $WORKDIR/$M3HEXPACKET | head -n 1`
	if [ -f $M3HEXTAR ]; then
		rm -rf /opt/control/*
		mkdir /opt/control/temp	
		tar -xf $M3HEXTAR -C /opt/control/temp
		sync
		cd /opt/control/temp
		md5sum -c md5sum.list
		if [ $? -eq 0 ]; then		
			cp -rf /opt/control/temp /opt/control/$M3HEXVERSION
			rm -rf /opt/control/temp
			echo "burn M3 firmware..." >> $LOG
			chmod a+x /opt/control/$M3HEXVERSION/ISPFinderPlusISP
			echo 267 > /sys/class/gpio/export
			echo "out" > /sys/class/gpio/gpio267/direction
			echo 1 > /sys/class/gpio/gpio267/value
			/opt/control/$M3HEXVERSION/ISPFinderPlusISP /opt/control/$M3HEXVERSION/$M3HEX
			echo "update $M3HEX success" >> $LOG
		else
			echo "md5sum failed" >> $LOG
			if [ -f $WORKDIR/failed.bmp ]; then
				cat $WORKDIR/failed.bmp > /dev/fb0
			fi
			sync
			sleep 1
			halt -f
		fi
	fi
fi

sync

ls -1t $WORKDIR/$SOFTWAREPACKET
if [ $? -eq 0 ]; then
	SOFTWAREXZ=`ls -1t $WORKDIR/$SOFTWAREPACKET | head -n 1`
	xz -d $SOFTWAREXZ
	SOFTWARETAR=`ls -1t $WORKDIR/$SOFTWAREPACKET | head -n 1`
	if [ -f $SOFTWARETAR ]; then
		if [ ! -d /opt/software/temp ]; then
			mkdir /opt/software/temp	
		fi
		tar -xf $SOFTWARETAR -C /opt/software/temp
		sync
		cd  /opt/software/
		softwareDir=$(ls -ld [0-9]* |awk '/^d/ {print $NF}')
		for oldSoftwareVer in $softwareDir 
		do
			echo $oldSoftwareVer
		done
		cd /opt/software/temp
		md5sum -c md5sum.list
		if [ $? -eq 0 ]; then	
			if [ "$oldSoftwareVer" > $SOFTWAREVERSION ]; then
				baseDir="0.0.0"
				echo $oldSoftwareVer ">" $SOFTWAREVERSION >> $LOG
				cp -rf /opt/software/$oldSoftwareVer  /opt/software/$baseDir
				cd /opt/software/
				rm -rf $oldSoftwareVer
			fi
			cp -f /opt/software/temp/auto_run.sh   /opt/ 
			cp -f /opt/software/temp/ffstartup-arm  /opt/ 
			cp -f /opt/software/temp/ffstartup.cfg  /opt/
			cp -f /opt/software/temp/mydaemon.out  /opt/ 			
			mkdir /opt/software/$SOFTWAREVERSION
			cp -rf /opt/software/temp/* /opt/software/$SOFTWAREVERSION
			rm -rf /opt/software/temp		
			echo "burn software firmware..." >> $LOG
			echo "update software success" >> $LOG
			sync
			ls -1t $WORKDIR/$LIBPACKET
			if [ $? -eq 0 ]; then
				LIBTXZ=`ls -1t $WORKDIR/$LIBPACKET | head -n 1`
				xz -d $LIBTXZ 
				LIBTAR=`ls -1t $WORKDIR/$LIBPACKET | head -n 1`
				if [ -f $LIBTAR ]; then
					if [ ! -d /opt/library/temp ]; then
						mkdir /opt/library/temp	
					fi
					tar -xf $LIBTAR -C /opt/library/temp
					sync
					cd  /opt/library/
					libDir=$(ls -ld [0-9]* |awk '/^d/ {print $NF}')
					for oldLibVer in $libDir 
					do
						echo $oldLibVer
					done
					cd /opt/library/temp
					md5sum -c md5sum.list
					if [ $? -eq 0 ]; then
						mkdir /opt/library/$LIBVERSION
						cp -rf /opt/library/temp/* /opt/library/$LIBVERSION
						rm -rf /opt/library/temp
						cd /opt/library/
						if [ "$oldLibVer" == $LIBVERSION ]; then
							echo "The same Lib version!" >> $LOG
						else
							rm -rf $oldLibVer
						fi
						cp /qt4.8.6-none/lib/fonts/code2000.ttf /opt/library/fonts/
						echo "update LIB" >> $LOG
						echo "burn LIB firmware..." >> $LOG
						sync
					else
						echo "md5sum failed" >> $LOG
						if [ -f $WORKDIR/failed.bmp ]; then
							cat $WORKDIR/failed.bmp > /dev/fb0
						fi
						sync
						sleep 1
						halt -f
					fi
				fi
			fi
			sync
		fi
	fi
fi

sync


echo "dispaly on lcd" >> $LOG
if [ -f $WORKDIR/complete.bmp ]
then
    cat $WORKDIR/complete.bmp > /dev/fb0
fi

if [ -f $WORKDIR/play ]; then
	echo "play complete music" >> $LOG
	chmod a+x $WORKDIR/play
	$WORKDIR/play 
fi

halt -f
